import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

class AddLayersDialog extends JDialog 
{
  public AddLayersDialog(JFrame parent, String[] layers)
    {super(parent, "AddLayers",true);
     Container contentpane=getContentPane();
     JPanel p1=new JPanel();
     JList layerlist=new JList(layers);
     JScrollPane scrollpane1=new JScrollPane(layerlist);
     p1.add("West",scrollpane1);
     p1.add("Center",new ButtonPanel(new String[]{"Add","Remove","Cancel","Ok"},this));
     DefaultListModel model=new DefaultListModel();
     JList chosenlist=new JList(model);
     JScrollPane scrollpane2=new JScrollPane(chosenlist);
     p1.add("East",scrollpane2);
     contentpane.add("Center",p1);
     setSize(240,120);
     }


} 

class ButtonPanel extends JPanel
{
 public ButtonPanel(String[] options,Object target)
 {
   setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
   for(int i=0;i<options.length;i++)
   {JButton b=new JButton(options[i]);
    b.addActionListener((ActionListener)target);
    add(b);
   }
 }
}

