
/**
 * Structure that stores information about all the parameters and
 * variables in a computation. This includes for each variable:
 *     *what is its kind? (PARAM, LOCAL, STATE..)
 *     *is it a local variable?
 *            if so, what is its current value?
 *     *which column is the (local?)/state var or parameter in?
 */
//class IDInfo implements TypeConstants //Yi Zheng May 14, 2002, for abstract dump method
public abstract class IDInfo implements TypeConstants
{     public int kind = RELIX_VOID;
   
   //inout Status is used only by the block type algorithm that is 
   //run when a computation is declared.
   public int inoutStatus = RELIX_VOID;

	public int type = RELIX_VOID; //added by Yi Zheng May 17, 2002
public IDInfo()
   {
   }   
 abstract void dump();
}
