/* Lili Zhu, August 2005
   detectFileDiffThread class supports the thread running for the
   display2D updating stage
*/
import java.util.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;

class detectFileDiffThread implements Runnable, TypeConstants
{
	String file;
	public static Relation r = null;
	public int copyflag = 0;  //implementable changes, so copy n.fig to _n.fig
	public static int polyline = 0;
	public static String name ="";
	Object[] options = {"Ok. I fixed it."};
	public detectFileDiffThread(String s)
	{
		file = s;
	}
	public void run()
	{
		try
		{
			while(Interpreter.done !=1)
			{
				if(Interpreter.nested == false && isPolyline(file)== true)
					//&& Interpreter.othershape == 0 && Interpreter.text_flag == 0) //POLYLINE(flat relation)
				{
					polyline = 1;
					//r = null;
					
					File f1 = new File(file);
					FileInputStream fin1 = new FileInputStream(f1);
					DataInputStream in = new DataInputStream(fin1);
					String s = "";
					int line_count = 0, obj_count = 0;
					//http://www.javacoffeebreak.com/java103/java103.html
					//read file into a string s
					while (in.available() !=0)
					{
						line_count ++;
						String tmp = in.readLine();
						if(line_count > 9 && tmp.charAt(0) != '\t')
							obj_count ++;
						s += tmp+"\n";
					}
					in.close();
					//System.out.println(obj_count+"_______________________");
					String [] s_arr = new String [obj_count];  //s_arr.length = obj_count
					String [] sline = new String [line_count ];
					int a = 0, b = 0;
					for (int i = 0; i < s.length() && b < line_count; i++)
					{
						if(s.charAt(i) == '\n')
						{
							sline[b] = s. substring(a, i);  //put each line of string s into an array
							a = i+1;
							b++;
						}
					}
	
					a = 0; b = -1;
					for (int j = 0; j < obj_count; j++) {  s_arr[j]="";  }
					while(a < line_count && b < obj_count)
					{
						if(a >= 9)
						{
							if( sline[a].charAt(0) != '\t') b++;
							s_arr[b] += sline[a]+"\n";  //treat each Xfig obj as a block, put it in a string
						}
						a++;
					}
	
					String newdata [][] = new String[s_arr.length][16];
					
					for (int j = 0; j < s_arr.length; j++)
					{
						int i = 0, t = 0;
						
						for(int k = 0; k < s_arr[j].length() &&  i < 16; k++)
						{
							if(s_arr[j].charAt(k) == ' ' || s_arr[j].charAt(k) == '\n' )
							{
								newdata[j][i] = s_arr[j].substring(t, k);
								//System.out.println(j+" .. "+i+" = "+newdata[j][i] );
								t = k + 1;
								i++;
							}
						}
					}
					//------------------------- For old copy  ------------------------------
					//------------------------- For _n.fig file ----------------------------
					File f_1 = new File("_"+file);
					FileInputStream fin_1 = new FileInputStream(f_1);
					DataInputStream in1 = new DataInputStream(fin_1);
					
					String s1 = "";
					int line_count1 = 0, obj_count1 = 0;
	
					while (in1.available() !=0)
					{
						line_count1 ++;
						String tmp = in1.readLine();
						if(line_count1>9 && tmp.charAt(0) != '\t')
							obj_count1 ++;
						s1 += tmp+"\n";
					}
					in1.close();
					
					String [] s_arr1 = new String [obj_count1];
					String [] sline1 = new String [line_count1 ];
					int a1 = 0, b1 = 0;
					
					for (int i = 0; i < s1.length() && b1 < line_count1; i++)
					{
						if(s1.charAt(i) == '\n')
						{
							sline1[b1] = s1. substring(a1, i);
							a1 = i+1;
							b1++;
						}
					}
					
					a1 = 0; b1 = -1;
					for (int j = 0; j < obj_count1;  j++) {  s_arr1[j]="";  }
					while(a1 < line_count1 && b1< obj_count1)
					{
						if( a1>= 9)
						{
							if( sline1[a1].charAt(0) != '\t') b1++;
							s_arr1[b1] += sline1[a1]+"\n";
						}
							a1++;
					}
					
					String olddata [][] = new String[s_arr1.length][16];
					
					for (int j = 0; j < s_arr1.length; j++)
					{
						int i = 0, t = 0;
						
						for(int k = 0; k < s_arr1[j].length() &&  i < 16; k++)
						{
							if(s_arr1[j].charAt(k) == ' ' || s_arr1[j].charAt(k) == '\n' )
							{
								olddata[j][i] = s_arr1[j].substring(t, k);
								t = k + 1;
								i++;
							}
						}
					}
					//System.out.println(s+"\n-----------\n"+s1);
					// Check whether the changes are implementable
					// if so, copy n.fig to _n.fig, get the new relation
					// else, popup window for warning message
					if(s.compareTo(s1) != 0)
					{
						//System.out.println("----  different -----");
						copyflag = 1;
						int line_style = 0, thickness = 1, pen_color = 0, fill_color = 7, depth = 50, area_fill = -1,
						join_style = 0, cap_style = 0;
						int forward_arrow = 0, backward_arrow = 0, num_points = 0;
						float style_val = 0;
						r = null;
						for (int i = 0; i < s_arr1.length; i++)
						{
							if(Integer.parseInt(olddata[i][2]) != 0)  line_style = 1;
							if(Integer.parseInt(olddata[i][3]) != 1)  thickness = 2;
							if(Integer.parseInt(olddata[i][4]) != 0)  pen_color = 1;
							if(Integer.parseInt(olddata[i][5]) != 7)  fill_color = 8;
							if(Integer.parseInt(olddata[i][6]) != 50) depth = 51;
							
							if(Integer.parseInt(olddata[i][8]) != -1)  area_fill = 0;
							if(Float.parseFloat(olddata[i][9]) != 0)   style_val = 1;
							if(Integer.parseInt(olddata[i][10]) != 0)  join_style = 1;
							if(Integer.parseInt(olddata[i][11]) != 0)  cap_style = 1;
							if(Integer.parseInt(olddata[i][13]) != 0)  forward_arrow = 1;
							if(Integer.parseInt(olddata[i][14]) != 0)  backward_arrow = 1;
						}
						/*Vector old_types = new Vector();
						for (int i = 0; i < s_arr1.length; i++)
						{
							if(!old_types.contains(olddata[i][0]) )
								old_types.addElement(olddata[i][0]);
						}
						for (int i = 0; i < old_types.size(); i++)
						{
						
							System.out.println(old_types.elementAt(i));
						}*
						for (int i = 0; i < s_arr.length; i++)
						{System.out.println("=="+newdata[i][0]);
							if(!old_types.contains(newdata[i][0]) )
							{
								copyflag = 0;
								System.out.println("Introduced new shapesss into the relation. Not implemented. ");
								//break;
							}
						}*/
						if(Interpreter.polyline_flag == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][15]) != Integer.parseInt(olddata[0][15]) )
								{
									copyflag = 0;
									String str = "Introduced new type of polyline object into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(Interpreter.polyline_flag == 1)
						{
							if(obj_count != obj_count1)
							{
								copyflag = 0;
								String str = "Introduced new type pf polyline objects into the relation. Not implemented.";
								str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
								int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
							}
						}
						if(line_style == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][2]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Line_style into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(thickness  == 1)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][3]) != 1)
								{
									copyflag = 0;
									String str = "Introduced new attribute Thickness into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(pen_color == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][4]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Pen_color into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(fill_color == 7)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][5]) != 7)
								{
									copyflag = 0;
									String str = "Introduced new attribute Fill_color into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(depth == 50)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][6]) != 50)
								{
									copyflag = 0;
									String str = "Introduced new attribute Depth into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(area_fill == -1)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][8]) != -1)
								{
									copyflag = 0;
									String str = "Introduced new attribute Area_fill into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(style_val== 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Float.parseFloat(newdata[i][9]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Style_value into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(join_style == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][10]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Join_style into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(cap_style == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][11]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Cap_style into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(forward_arrow == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][13]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Forward_arrow into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						if(backward_arrow == 0)
						{
							for (int i = 0; i < s_arr.length; i++)
							{
								if(Integer.parseInt(newdata[i][14]) != 0)
								{
									copyflag = 0;
									String str = "Introduced new attribute Backward_arrow into the relation. Not implemented.";
									str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button";
									int n = JOptionPane.showOptionDialog(null, str, "Error", JOptionPane.OK_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[0]);
								}
							}
						}
						
						if(copyflag == 1)  // copy n.fig to _n.fig: newfile -> oldfile
						{
							try
							{
								String str;
								String cmd = "cp "+file+" _"+file;
								
								Process p = Runtime.getRuntime().exec(cmd);
								
								DataInputStream in0 = new DataInputStream(p.getInputStream());
								
								try 
								{
									while ((str = in0.readLine()) != null)
									{
										System.out.println(str);
									}
								} 
								catch (IOException e)
								{
									System.err.println(e);
									System.exit(0);
								}
							} 
							catch (IOException e1)
							{
								System.err.println(e1);
								System.exit(1);
							}
							//working on the return Relation
							//because in a flat relation, only 1 kind of xfig object can exist,
							//only look at the first xfig object, then we can decide the type of the obj
							//and what attributes (line_color...) are included
							
							int n_attr = 0;
							Domain newDomx = null, newDomx1 = null, newDomx2 = null, newDomx3 = null, newDomy = null, newDomy1 = null, newDomy2 = null, newDomy3 = null, newDoms = null; 
							Domain newDom2 = null, newDom3= null, newDom4 = null, newDom5 = null, newDom6 = null, newDom8 = null, newDom9 = null, newDom10 = null, newDom11 = null, newDom13 = null, newDom14 = null; 
							
							//if(s_arr[0].charAt(0) == '2')  //polyline
							//{
							if(Integer.parseInt(newdata[0][2]) != 0)
							{
								n_attr ++;
								//line_style
								newDom2 = new Domain("ls", INTEGER, 0, null);
								Global.environment.put(newDom2);
							}
							if(Integer.parseInt(newdata[0][3]) != 1)
							{
								n_attr ++;
								//thickness
								newDom3 = new Domain("lt", INTEGER, 0, null);
								Global.environment.put(newDom3);
							}
							if(Integer.parseInt(newdata[0][4]) != 0)
							{
								n_attr ++;
								//pen_color
								newDom4 = new Domain("lc", INTEGER, 0, null);
								Global.environment.put(newDom4);
							}
							if(Integer.parseInt(newdata[0][5]) != 7)
							{
								n_attr ++;
								//fill_color
								newDom5 = new Domain("fc", INTEGER, 0, null);
								Global.environment.put(newDom5);
							}
							if(Integer.parseInt(newdata[0][6]) != 50)
							{
								n_attr ++;
								//depth
								newDom6 = new Domain("dep", INTEGER, 0, null);
								Global.environment.put(newDom6);
							}
							if(Integer.parseInt(newdata[0][8]) != -1)
							{
								n_attr ++;
								//fill_pattern
								newDom8 = new Domain("fp", INTEGER, 0, null); 
								Global.environment.put(newDom8);
							}
							if(Float.parseFloat(newdata[0][9]) != 0)
							{
								n_attr ++;
								//styleval
								newDom9 = new Domain("sl", FLOAT, 0, null); 
								Global.environment.put(newDom9);
							}
							if(Integer.parseInt(newdata[0][10]) != 0)
							{
								n_attr ++;
								//fill_pattern
								newDom10 = new Domain("js", INTEGER, 0, null);
								Global.environment.put(newDom10);
							}
							if(Integer.parseInt(newdata[0][11]) != 0)
							{
								n_attr ++;
								//fill_pattern
								newDom11 = new Domain("cs", INTEGER, 0, null);
								Global.environment.put(newDom11);
							}
							if(Integer.parseInt(newdata[0][13]) != 0)
							{
								n_attr ++;
								//fill_pattern
								newDom13 = new Domain("fa", INTEGER, 0, null);
								Global.environment.put(newDom13);
							}
							if(Integer.parseInt(newdata[0][14]) != 0)
							{
								n_attr ++;
								//fill_pattern
								newDom14 = new Domain("ba", INTEGER, 0, null);
								Global.environment.put(newDom14);
							}
							
							int n_points = Integer.parseInt(newdata[0][15]);
							
							//if ( n_points >= 4) n_points = n_points -1 ;  916
							String points [][] = new String[obj_count][n_points*2];
							int aftertab = 0, tmp = 0;
	
							for (int j = 0; j < obj_count; j++)
							{
								int i = 0, t = 0;
								aftertab = 0;
								for(int k = 0; k < s_arr[j].length() &&  i < n_points*2; k++)
								{
									tmp = k;
									if(s_arr[j].charAt(k) == '\t')
									{
										tmp = k + 1; aftertab = tmp; 
										t = aftertab + 1;
									}
									if(k > aftertab && aftertab != 0)
									{
										if(s_arr[j].charAt(k) == ' '|| s_arr[j].charAt(k) == '\n')
										{
											points[j][i] = s_arr[j].substring(t, k);
											//System.out.println(j+" .. "+i+" = "+points[j][i]);
											t = k + 1;
											i++;
										}
									}
								}
							}
							if(n_points == 4 && Interpreter.polyline_flag != 1) n_points -= 1; //triangle
							if(Interpreter.polyline_flag != 1)
								n_attr += 2*n_points; //number of attributes = 2*number of points
							else
								n_attr += 3; //( x, y, seq)
							
							Domain [] d = new Domain[n_attr];
							int d_idx = 2*n_points;  //domain_index
								
							if ( n_points == 1 && Interpreter.polyline_flag != 1) //(x, y)
							{
								newDomx = new Domain("x", INTEGER, 0, null);   //type= intg= 2
								Global.environment.put(newDomx);
								newDomy = new Domain("y", INTEGER, 0, null);
								Global.environment.put(newDomy);
								d[0] = newDomx;
								d[1] = newDomy;
							}
							if ( n_points == 2 && Interpreter.polyline_flag != 1) //(x1, y1, x2, y2)
							{
								newDomx1 = new Domain("x1", INTEGER, 0, null);
								Global.environment.put(newDomx1);
								newDomy1 = new Domain("y1", INTEGER, 0, null);
								Global.environment.put(newDomy1);
								newDomx2 = new Domain("x2", INTEGER, 0, null);
								Global.environment.put(newDomx2);
								newDomy2 = new Domain("y2", INTEGER, 0, null);
								Global.environment.put(newDomy2);
								d[0] = newDomx1;
								d[1] = newDomy1;
								d[2] = newDomx2;
								d[3] = newDomy2;
							}
							if ( n_points == 3 && Interpreter.polyline_flag != 1)  //(x1, y1, x2, y2, x3, y3)
							{
								newDomx1 = new Domain("x1", INTEGER, 0, null);
								Global.environment.put(newDomx1);
								newDomy1 = new Domain("y1", INTEGER, 0, null);
								Global.environment.put(newDomy1);
								newDomx2 = new Domain("x2", INTEGER, 0, null);
								Global.environment.put(newDomx2);
								newDomy2 = new Domain("y2", INTEGER, 0, null);
								Global.environment.put(newDomy2);
								newDomx3 = new Domain("x3", INTEGER, 0, null);
								Global.environment.put(newDomx3);
								newDomy3 = new Domain("y3", INTEGER, 0, null);
								Global.environment.put(newDomy3);
								d[0] = newDomx1;
								d[1] = newDomy1;
								d[2] = newDomx2;
								d[3] = newDomy2;
								d[4] = newDomx3;
								d[5] = newDomy3;
							}
							if(Interpreter.polyline_flag == 1)  //(x, y, seq) polygon
							{
								d_idx = 3;  //for polygon, d_idx != 2*n_points
								newDomx = new Domain("x", INTEGER, 0, null);
								Global.environment.put(newDomx);
								newDomy = new Domain("y", INTEGER, 0, null);
								Global.environment.put(newDomy);
								newDoms = new Domain("se", INTEGER, 0, null);
								Global.environment.put(newDoms);
								d[0] = newDomx;
								d[1] = newDomy;
								d[2] = newDoms;
							}
							
							while(d_idx < n_attr )
							{
								if(Integer.parseInt(newdata[0][2]) != 0)  { d[d_idx] = newDom2; d_idx++; }
								if(Integer.parseInt(newdata[0][3]) != 1)  { d[d_idx] = newDom3; d_idx++; }
								if(Integer.parseInt(newdata[0][4]) != 0)  { d[d_idx] = newDom4; d_idx++; }
								if(Integer.parseInt(newdata[0][5]) != 7)  { d[d_idx] = newDom5; d_idx++; }
								if(Integer.parseInt(newdata[0][6]) != 50) { d[d_idx] = newDom6; d_idx++; }
								if(Integer.parseInt(newdata[0][8]) != -1) { d[d_idx] = newDom8; d_idx++; }
								if(Float. parseFloat(newdata[0][9]) != 0) { d[d_idx] = newDom9; d_idx++; }
								if(Integer.parseInt(newdata[0][10]) != 0) { d[d_idx] = newDom10; d_idx++; }
								if(Integer.parseInt(newdata[0][11]) != 0) { d[d_idx] = newDom11; d_idx++; }
								if(Integer.parseInt(newdata[0][13]) != 0) { d[d_idx] = newDom13; d_idx++; }
								if(Integer.parseInt(newdata[0][14]) != 0) { d[d_idx] = newDom14; d_idx++; }
							}
							
							name = Interpreter.nextTempName();
							File f = new File(name);
							
							
							BlockOutputStream vocab = null;
							final int BUF_SIZE = 16 * 1024;
							try 
							{
								vocab = new BlockOutputStream(name, BUF_SIZE);
							}
							catch (IOException e)
							{
								try
								{
									if (vocab != null) vocab.close();
								}
								catch (IOException ex)
								{
								}
								finally 
								{
									throw new InterpretError("IO error in saving: " + name);
								}
							}
	
							String space = new String("^F");
							String nl = new String("\n");
							
							try
							{
								if(Interpreter.polyline_flag != 1)
								{
									r = new Relation(name, d, RELATION, obj_count, n_attr, 0, null, Global.environment);
									Global.environment.put(r);
									for (int i = 0; i < obj_count; i++)
									{
										for (int j = 0; j < 2*n_points; j++)
										{
											vocab.writeString(points[i][j]);
											vocab.writeByte(6);
											
											if(j == n_points*2-1)
											{
												if(newDom2 != null)
												{
													vocab.writeString(newdata[i][2]);
													vocab.writeByte(6);
												}
												if(newDom3 != null)
												{
													vocab.writeString(newdata[i][3]);
													vocab.writeByte(6);
												}
												if(newDom4 != null)
												{
													vocab.writeString(newdata[i][4]);
													vocab.writeByte(6);
												}
												if(newDom5 != null)
												{
													vocab.writeString(newdata[i][5]);
													vocab.writeByte(6);
												}
												if(newDom6 != null)
												{
													vocab.writeString(newdata[i][6]);
													vocab.writeByte(6);
												} 
												if(newDom8 != null)
												{
													vocab.writeString(newdata[i][8]);
													vocab.writeByte(6);
												}
												if(newDom9 != null)
												{
													vocab.writeString(newdata[i][9]);
													vocab.writeByte(6);
												}
												if(newDom10 != null)
												{
													vocab.writeString(newdata[i][10]);
													vocab.writeByte(6);
												}
												if(newDom11 != null)
												{
													vocab.writeString(newdata[i][11]);
													vocab.writeByte(6);
												}
												if(newDom13 != null)
												{
													vocab.writeString(newdata[i][13]);
													vocab.writeByte(6);
												}
												if(newDom14 != null)
												{
													vocab.writeString(newdata[i][14]);
													vocab.writeByte(6);
												}
											}
										} vocab.writeBytes(nl);
									}
								}
								else
								{
									//if the last point == first point, then n_points = n_points -1
									//if(points[0][0].compareTo(points[0][2*n_points-2])==0 && points[0][1].compareTo(points[0][2*n_points-1])== 0 )
									//n_points = n_points -1;
									
									r = new Relation(name, d, RELATION, n_points, n_attr, 0, null, Global.environment);
									Global.environment.put(r);
									
									for (int j = 0; j < n_points; j++)
									{
										vocab.writeString(points[0][2*j]);
										vocab.writeByte(6);
										vocab.writeString(points[0][2*j+1]);
										vocab.writeByte(6);
										vocab.writeString(""+(j+1));  //writing the seq
										vocab.writeByte(6);
										
										if(newDom2 != null)
										{
											vocab.writeString(newdata[0][2]);
											vocab.writeByte(6);
										}
										if(newDom3 != null)
										{
											vocab.writeString(newdata[0][3]);
											vocab.writeByte(6);
										}
										if(newDom4 != null)
										{
											vocab.writeString(newdata[0][4]);
											vocab.writeByte(6);
										}
										if(newDom5 != null)
										{
											vocab.writeString(newdata[0][5]);
											vocab.writeByte(6);
										}
										if(newDom6 != null)
										{
											vocab.writeString(newdata[0][6]);
											vocab.writeByte(6);
										} 
										if(newDom8 != null)
										{
											vocab.writeString(newdata[0][8]);
											vocab.writeByte(6);
										}
										if(newDom9 != null)
										{
											vocab.writeString(newdata[0][9]);
											vocab.writeByte(6);
										}
										if(newDom10 != null)
										{
											vocab.writeString(newdata[0][10]);
											vocab.writeByte(6);
										}
										if(newDom11 != null)
										{
											vocab.writeString(newdata[0][11]);
											vocab.writeByte(6);
										}
										if(newDom13 != null)
										{
											vocab.writeString(newdata[0][13]);
											vocab.writeByte(6);
										}
										if(newDom14 != null)
										{
											vocab.writeString(newdata[0][14]);
											vocab.writeByte(6);
										}
										vocab.writeBytes(nl);
									}
								}
								vocab.close();
								
								String  path = System.getProperty("user.dir");
								if ( Global.DataFileSet.containsKey(name))
								{
									String mode = Global.DataFileSet.get(name).toString();
									Runtime rt = Runtime.getRuntime();
									Process pr = rt.exec("chmod "+ mode + " " + name);
								}
								else if (path.indexOf("public_aldatp") >= 0)
								{
									Runtime rt = Runtime.getRuntime();
									Process pr = rt.exec("chmod 666 " + name);
								}
							}
							catch (IOException e) {}
							r.load();
						
							RelTable reltable = Global.environment.reltable;
							Hashtable table = reltable.getRelTable();
							Relation rel = (Relation) table.get(name);
							if(rel != null )
								reltable.rmRel(name); //remove the temp relation r from the reltable
							
						} //end of copyflag == 1
					
					} // end of if(s.compareTo(s1)!= 0)
				
				} //end of no text/no othershape(arc...)/no nested relatoin
			
				else //other shapes/text, implementation is coming later, now only warning message
				{
					polyline = 0;
					
					if(Interpreter.compare2Files(file, "_#"+file) == 1)
					{
						String str = "Currently, Updating any shape other than polyline and updating nested relation are not implemented.";
						str = str+"\n(Minimize this popup window,) fix the error, then (maximize this window and) click the button.";
						str += "\nIf quit now, the changes you made won't be saved.";
						int n = JOptionPane.showOptionDialog(null, str, "Warning", JOptionPane.OK_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
						//JOptionPane.showMessageDialog(null, str, "warning", JOptionPane.WARNING_MESSAGE);
					}
				}
			Thread.sleep (3000);
			}
			
		} //end of try {}
		
		catch (Exception e) 
		{
			System.exit(1);
		}
	}

	private boolean isPolyline(String file)
	{
		boolean flag = true;
		try
		{
			File f1 = new File(file);
			FileInputStream fin1 = new FileInputStream(f1);
			DataInputStream in = new DataInputStream(fin1);
			int line_count = 0;
			while (in.available() != 0)
			{
				line_count ++;
				String tmp = in.readLine();
				if(line_count > 9 && tmp.charAt(0) != '\t')
				{
					if((tmp.substring(0,1)).compareTo("2") != 0 )//nonpolyline
					{
						//System.out.println(tmp+"\nchar ="+tmp.charAt(0));
						flag = false;
						break;
					}
				}
				
			}
			in.close();
		}
		catch (Exception e) 
		{
			System.exit(1);
		}
		return flag;
	}
}

