public class NodeAttribute extends SimpleNode {
  private String name, value;

  public NodeAttribute(String n, String v) {
    super("attribute");
    name = n;
    if (v == null) {
      value = "#IMPLIED";
    } else {
      value = v;
    }
  }

  public String toString() {
    return identifier + ": " + name + "=" + value;
  }
}
