/* JJT: 0.2.2 */




public class ASTBitwiseXorNode extends SimpleNode {
  ASTBitwiseXorNode(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTBitwiseXorNode(id);
  }

  public void interpret()
  {
     jjtGetChild(0).interpret();
     jjtGetChild(1).interpret();

     if (stack[top] instanceof Boolean)
        stack[--top] = new Boolean(((Boolean)stack[top]).booleanValue() ^
                                ((Boolean)stack[ + 1]).booleanValue());
     else if (stack[top] instanceof Integer)
        stack[--top] = new Integer(((Integer)stack[top]).intValue() ^
                                ((Integer)stack[ + 1]).intValue());
  }
}
