import java.io.*;
import java.util.StringTokenizer;

import antlr.DumpASTVisitor;
import antlr.collections.AST;
import antlr.ASTFactory;

class Main {
	public static String sqlAldat ="";
	private static int undef = -1;
	private static boolean star = false;
	private static boolean like = false;
	private static boolean into = false;
	private static String[] rel = null;
	private static String[] dom = null;
	private static String[] tableList = new String[2];
    //static DumpASTVisitor v1 = new DumpASTVisitor();
    public static void main(String[] args) {
        //try {
            InputStream in = System.in;
            if (args.length > 0) {
            	//System.out.println(translate(true, args[0], "some", null));
            	System.out.println(translate(true, args[0], null));
            }
            /*else {
            	
            }
            String [] tmpRel = {"c", "c", "d"};
            String [] tmpDom = {"a", "f", "e"};
            rel = tmpRel;
            dom = tmpDom;
            SqlLexer lexer = new SqlLexer(new DataInputStream(in));
            SqlParser parser = new SqlParser(lexer);
            parser.start_rule();
            AST sqlTree = parser.getAST();
            DumpASTVisitor v = new DumpASTVisitor();
            v.visit(sqlTree);
            while (sqlTree!=null){
                sqlAldat += visit(sqlTree);
                sqlTree = sqlTree.getNextSibling();
            }
            System.out.println(sqlAldat);
        } catch(Exception e) {
            System.err.println("exception: "+e);
        }*/
    }
    public static String translate(boolean isPath, String s, Object[] d){
    	try{
    	 SqlLexer lexer = null;
    		if (d!=null){ 
    			rel = (String[])d[0];
    			dom = (String[])d[1];
    		}
    		else {
                String [] tmpRel = {"c", "c", "d"};
                String [] tmpDom = {"a", "f", "e"};
                rel = tmpRel;
                dom = tmpDom;
    		}
            String ret = "";
            String[] intoDest = null;
            int numLines = 0;
        if (isPath) {
        	FileInputStream fis =  new FileInputStream(s);
        	int x= fis.available();
        	byte b[]= new byte[x];
        	fis.read(b);
        	String sTempFile = new String(b);
        	StringTokenizer sToken = new StringTokenizer(sTempFile, ";");
        	numLines = sToken.countTokens();
        	intoDest = new String[numLines];
        	int tmp = 0;
        	int dep = 0;
        	String sTemp = "";
    		sTempFile = "";
        	while(sToken.hasMoreTokens()){
        		sTemp = sToken.nextToken();
            	if (sTemp.indexOf("into") != -1){
            		dep = sTemp.indexOf("into");
            		intoDest[tmp] = sTemp.substring(dep+5, sTemp.indexOf("from", dep)) + "<- ";
            		sTempFile = sTempFile + sTemp.substring(0, dep) + sTemp.substring(sTemp.indexOf("from", dep)) + ";";
            	}
            	else {
            		sTempFile = sTempFile + sTemp + ";";
            	}
        		tmp++;
        	}
        	InputStream in = (InputStream) new ByteArrayInputStream(sTempFile.getBytes());
            lexer = new SqlLexer(in);
        	/*
            FileInputStream in = new FileInputStream(s);
            lexer = new SqlLexer(new DataInputStream(in));*/
        }
        else {
        	String sTempFile = s; 
        	StringTokenizer sToken = new StringTokenizer(sTempFile, ";");
        	numLines = sToken.countTokens();
        	intoDest = new String[numLines];
        	int tmp = 0;
        	int dep = 0;
        	String sTemp = "";
    		sTempFile = "";
        	while(sToken.hasMoreTokens()){
        		sTemp = sToken.nextToken();
            	if (sTemp.indexOf("into") != -1){
            		dep = sTemp.indexOf("into");
            		intoDest[tmp] = sTemp.substring(dep+5, sTemp.indexOf("from", dep)) + "<- ";
            		sTempFile = sTempFile + sTemp.substring(0, dep) + sTemp.substring(sTemp.indexOf("from", dep)) + ";";
            	}
            	else {
            		sTempFile = sTempFile + sTemp + ";";
            	}
        		tmp++;
        	}
        	InputStream in = (InputStream) new ByteArrayInputStream(sTempFile.getBytes());
            lexer = new SqlLexer(in);        
        }
        SqlParser parser = new SqlParser(lexer);
        parser.start_rule();
        AST sqlTree = parser.getAST();
        boolean first = false;
        for(int i = 0; i<numLines;i++){
    		if (first){
	    		ret += "\n";
    		}
    		if (intoDest[i] == null){
                ret += visit(sqlTree);
    		}
    		else {
    			String tmp2 = visit(sqlTree);
    			if (tmp2.indexOf("\n")!=-1){
    				int dep2 = tmp2.lastIndexOf("\n");
                    ret += tmp2.substring(0,dep2+1) + intoDest[i] + tmp2.substring(dep2+1);
    			}
    			else{
                    ret += intoDest[i] + tmp2;
    			}
    		}
            sqlTree = sqlTree.getNextSibling();
            if (!first){
        		first = true;
            }
        }
        return ret;
    } 
	catch (FileNotFoundException e) {
		System.err.println("INSQL : SQL file " + s + " not found");
        return "";
		}
	catch(Exception e) {
        System.err.println("exception: "+e);
        return "";
    }
    }
    public static String translate(boolean isPath, String s, String temp, Object[] d){
    	try{
    	 SqlLexer lexer = null;
    		if (d!=null){ 
    			rel = (String[])d[0];
    			dom = (String[])d[1];
    		}
    		else {
                String [] tmpRel = {"c", "c", "d"};
                String [] tmpDom = {"a", "f", "e"};
                rel = tmpRel;
                dom = tmpDom;
    		}
            String ret = "";
            String[] intoDest = null;
            boolean[] isSelect = null;
            int numLines = 0;
            boolean insertTemp = false;
        if (isPath) {
        	FileInputStream fis =  new FileInputStream(s);
        	int x= fis.available();
        	byte b[]= new byte[x];
        	fis.read(b);
        	String sTempFile = new String(b);
        	StringTokenizer sToken = new StringTokenizer(sTempFile, ";");
        	numLines = sToken.countTokens();
        	intoDest = new String[numLines];
        	isSelect = new boolean[numLines];
        	int tmp = 0;
        	int dep = 0;
        	String sTemp = "";
    		sTempFile = "";
        	while(sToken.hasMoreTokens()){
        		sTemp = sToken.nextToken();
        		isSelect[tmp]= (sTemp.indexOf("select")!=-1);
            	if (sTemp.indexOf("into") != -1){
            		dep = sTemp.indexOf("into");
            		intoDest[tmp] = sTemp.substring(dep+5, sTemp.indexOf("from", dep)) + "<- ";
            		sTempFile = sTempFile + sTemp.substring(0, dep) + sTemp.substring(sTemp.indexOf("from", dep)) + ";";
            	}
            	else {
            		sTempFile = sTempFile + sTemp + ";";
            	}
        		tmp++;
        	}
        	InputStream in = (InputStream) new ByteArrayInputStream(sTempFile.getBytes());
            lexer = new SqlLexer(in);
        	/*
            FileInputStream in = new FileInputStream(s);
            lexer = new SqlLexer(new DataInputStream(in));*/
        }
        else {
        	String sTempFile = s; 
        	StringTokenizer sToken = new StringTokenizer(sTempFile, ";");
        	numLines = sToken.countTokens();
        	intoDest = new String[numLines];
        	isSelect = new boolean[numLines];
        	int tmp = 0;
        	int dep = 0;
        	String sTemp = "";
    		sTempFile = "";
        	while(sToken.hasMoreTokens()){
        		sTemp = sToken.nextToken();
        		isSelect[tmp]= (sTemp.indexOf("select")!=-1);
            	if (sTemp.indexOf("into") != -1){
            		dep = sTemp.indexOf("into");
            		intoDest[tmp] = sTemp.substring(dep+5, sTemp.indexOf("from", dep)) + "<- ";
            		sTempFile = sTempFile + sTemp.substring(0, dep) + sTemp.substring(sTemp.indexOf("from", dep)) + ";";
            	}
            	else {
            		sTempFile = sTempFile + sTemp + ";";
            	}
        		tmp++;
        	}
        	InputStream in = (InputStream) new ByteArrayInputStream(sTempFile.getBytes());
            lexer = new SqlLexer(in);        
        }
        for(int i=numLines;i>0;i--){
        	if (isSelect[i-1] && intoDest[i-1]==null){
        		intoDest[i-1] = temp + " <- ";
        		insertTemp = true;
        		break;
        	}
        }
        SqlParser parser = new SqlParser(lexer);
        parser.start_rule();
        AST sqlTree = parser.getAST();
        //DumpASTVisitor v = new DumpASTVisitor();
        //v.visit(sqlTree);
        boolean first = false;
        for(int i = 0; i<numLines;i++){
    		if (first && (!isSelect[i] || intoDest[i]!=null)){
	    		ret += "\n";
    		}
    		if (intoDest[i] != null){
    			String tmp2 = visit(sqlTree);
    			if (tmp2.indexOf("\n")!=-1){
    				int dep2 = tmp2.lastIndexOf("\n");
                    ret += tmp2.substring(0,dep2+1) + intoDest[i] + tmp2.substring(dep2+1);
    			}
    			else{
                    ret += intoDest[i] + tmp2;
    			}
    		}
    		else {
    			if (!isSelect[i]){
                    ret += visit(sqlTree);
    			}
    		}
            sqlTree = sqlTree.getNextSibling();
            if (!first){
        		first = true;
            }
        }
        if (!insertTemp){
        	ret+= "\n " + temp + "<-[];";
        }
        return ret;
    } 
	catch (FileNotFoundException e) {
		System.err.println("INSQL : SQL file " + s + " not found");
        return "";
		}
	catch(Exception e) {
        System.err.println("exception: "+e);
        return "";
    }
    }
    public static String visit(AST sqlTree){
    	String s = "";
    	AST fSon;
    	AST group = null;
    	AST whereCondition = null;
    	switch (sqlTree.getType()) {
    	case 1:
    		return s;
    	case 4:
    		group = nextGroupBy(sqlTree.getFirstChild());
    		break;
    	case 5:
    		group = nextGroupBy(sqlTree);
    		if (sqlTree.getFirstChild().getType()==25) {
        		star  = true;
    			return s;
    		}
    		s += addAliases(sqlTree.getFirstChild(), group);
    		s += addExpression(sqlTree.getFirstChild());
    		//if (haveHaving(sqlTree)) {
    			//s += addAliases(nextHaving(sqlTree), nextGroupBy(sqlTree));
    			//}
    		s += "[";
    		break;
    	case 6:
    		break;
    	case 7:
    		//(new DumpASTVisitor()).visit(parseWhereCondition(sqlTree.getFirstChild()));
    		whereCondition = parseWhereCondition(sqlTree.getFirstChild());//" where ";
        	s += " where " +  visit(whereCondition);
        	return s;
    	case 8:
    		break;
    	case 9:
    		if (haveAlias(sqlTree)){
    			return s;
    		}
    		if (sqlTree.getNextSibling()!=null && sqlTree.getNextSibling().getType()==26){
    			return s;    			
    		}
    		break;
    	case 10:
    		break;
    	case 12:
    		break;
    	case 14:
    		s += "*";
    		return s;
    	case 16:
    		s += " ujoin ";
    		break;
    	case 19:
    		break;
    	case 21:
    		return s;
    	case 22:
    		if (sqlTree.getNextSibling().getType() == 6){
    			int numTables = numberOfTables(sqlTree.getNextSibling());
    			fSon = sqlTree.getNextSibling().getNextSibling();
        		if (numTables > 1){
        			tableList[0] = visit(sqlTree.getNextSibling().getFirstChild()); 
        			tableList[1] = visit(sqlTree.getNextSibling().getFirstChild().getNextSibling().getNextSibling());
            		if (fSon.getType()==23){
            			fSon = fSon.getNextSibling();
            			whereCondition = parseWhereCondition(fSon.getFirstChild());
            			if (isJoinGlobal(whereCondition)){
            				String tmp = visitWhere(whereCondition);
        					if (tmp != ""){
        						s += " where " + tmp;
        					}
            	        	if (!star || tmp!="") {
            	        		s += " in ";
            	        	}
        	        		star = false;
            	        	s += visitWhereJoin(whereCondition);
            	        	if (like) {
            	        		s += ")";
            	        	}
        	        		like = false;
            			}
            			else {
            				s += " where " + visitWhere(whereCondition);
        					s += " in ";
        	        		star = false;
            	        	s += "(" + visit(sqlTree.getNextSibling().getFirstChild()) + " ujoin " + visit(sqlTree.getNextSibling().getFirstChild().getNextSibling().getNextSibling()) + ")";
            	        	if (like) {
            	        		s += ")";
            	        	}
        	        		like = false;
            			}
            		}
            		else {
        	        	if (!star) {
        	        		s += " in ";
        	        	}
    	        		star = false;    	        		
    	        		s += "(" + visit(sqlTree.getNextSibling().getFirstChild()) + " ujoin " + visit(sqlTree.getNextSibling().getFirstChild().getNextSibling().getNextSibling()) +")";
        	        	if (like) {
        	        		s += ")";
        	        	}
    	        		like = false;
            		}
        		}
        		else {
        			if (fSon.getType()==23){
            			fSon = fSon.getNextSibling();
            			whereCondition = parseWhereCondition(fSon.getFirstChild());
            			s += " where " + visitWhere(whereCondition);
    					s += " in ";
            	        s += visit(sqlTree.getNextSibling());
        	        	if (like) {
        	        		s += ")";
        	        	}
    	        		like = false;
            		}
            		else {
        	        	if (!star) {
        	        		s += " in ";
        	        	}
    	        		star = false;
        	        	s += visit(sqlTree.getNextSibling());
        	        	if (like) {
        	        		s += ")";
        	        	}
    	        		like = false;
            		}
        		}
    		}
    		else {
    			s += " in ";
    		}
        	break;
    	case 23:
    		break;
    	case 26:
    		return s;
    	case 29:
    		return s;
    	case 33:
    		String tmp = (sqlTree.getText()).replaceAll("'", "\"");
    		tmp = tmp.replaceAll("%", "");
    		s+=tmp;
    		break;
    	case 86:
    	case 87:
    		if (sqlTree.getNumberOfChildren() > 0){
	    		s+=visit(sqlTree.getFirstChild()) + " " + sqlTree.getText() + " " + visit(sqlTree.getFirstChild().getNextSibling());
	    		return s;
    		}
    		else {
    			s+= " " + sqlTree.getText();
    			break;
    		}
    	case 89:
    		if (sqlTree.getNumberOfChildren() > 0){
	    		s+=" " + sqlTree.getText() + " " + visit(sqlTree.getFirstChild().getNextSibling());
	    		return s;
    		}
    		else {
    			s+= " " + sqlTree.getText();
    			break;
    		}
    	case 91:
    		s+= "\" in (grep(ATT) ";
    		like = true;
    		break;
    	case 107:
    		break;
    	case 108:
    		s+= " where ";
    		break;
    	case 115:
    		s+= "update ";
    		break;
    	case 118:
    		s+= "update ";
    		break;
    	case 119:
    		s+= " change ";
    		break;
    	case 125:
    		s+= "(";
    		break;
    	case 126:
    	case 127:
    	case 128:
    		break;
    	default:
    		s += sqlTree.getText();
    		break;
    	}

    	//System.out.println("Line " + sqlTree.getText() + " " + sqlTree.getNumberOfChildren()+ " " + sqlTree.getType());
        
    	
    	//recursion
    	int numChild = sqlTree.getNumberOfChildren();
        if (numChild > 0){
        	fSon = sqlTree.getFirstChild();
    		if (fSon !=null && fSon.getType() != 115 && fSon.getType() != 118){
	        	while (fSon != null){
	        		if (fSon.getType() == 12){
		        		if (sqlTree.getType() == 5){
		        			if (!haveAlias(fSon)){
								if (undef == 0){
									s += "No_Name ";
								}
								else {
									s += "No_Name" + undef  + " ";
								}
		            		}
		        		}
		        		else {
		        			s += visitGroup(fSon, group);
		        		}
	            		fSon = fSon.getNextSibling();
	            	}
	        		else if (sqlTree.getType() == 5 && isExpression(fSon)){
						if (undef == 0){
							s += "No_Name ";
						}
						else {
							s += "No_Name" + undef  + " ";
						}
	        			fSon = nextExpression(fSon);
	        		}
	            	else {
		        		if (fSon.getType()!=7 && fSon.getType()!=6) {
		                	s += visit(fSon);
		        		}
		        		if (fSon.getType() == 107){
		        			fSon = fSon.getNextSibling().getNextSibling();
		        			//s += ";";
		        			 //return s;
		        		}
		        		fSon = fSon.getNextSibling();
	            	}
	            }
        	}
        	else if (fSon.getType() == 115){
        		s += visit(fSon);
        		String sTmp ="";
        		String sTmp2 ="";
        		while (fSon.getNextSibling().getType() != 119){
	        		fSon = fSon.getNextSibling();
                	s += visit(fSon);
	            }
        		fSon = fSon.getNextSibling();
            	s += visit(fSon);
        		fSon = fSon.getNextSibling();
        		sTmp +=visit(fSon); 
        		s += visit(fSon); 
        		fSon = fSon.getNextSibling().getNextSibling();
        		sTmp2 +=visit(fSon); 
        		fSon = fSon.getNextSibling();
        		if (fSon!= null && fSon.getType() == 23){
        			whereCondition = parseWhereCondition(fSon.getNextSibling());
        			s += "<- if " + visit(whereCondition); 
        			s = s.replace(";", ""); 		
        		}
        		s += " then " + sTmp2 + " else " + sTmp + ";";
        		return s;
        	}

        	else {
        		s += visit(fSon);
        		String sTmp ="";
        		fSon = fSon.getNextSibling().getNextSibling();
            	sTmp += visit(fSon);
            	s += visit(fSon) + " delete ";
        		fSon = fSon.getNextSibling();
        		if (fSon.getType() == 23){
        			s += "where " + visit(parseWhereCondition(fSon.getNextSibling())); 
        			s = s.replace(";", "");
        			s += " in ";	        		
        		}
        		s += sTmp + ";";
        		return s;
        	}
        }
        
        switch (sqlTree.getType()) {
	    	case 5:
	        	s += "]";
	    		break;

	    	case 4:
	    	case 6:
	    	case 7:
	    	case 8:
	    	case 9:
	    	case 10:
	    	case 19:
	    	case 22:
	    	case 23:
	    	case 33:
	    		break;
	    	case 86:
	    	case 87:
	    		s+=" ";
	    		break;
	    	case 125:
	    		s+= ")";
	    		break;
	    	case 126:
	    	case 127:
	    	case 128:
	    		break;
	    	default:
	    		break;
    	}
		return s;
    }
	private static AST nextExpression(AST sqlTree) {
    	AST fSon = sqlTree;
		while (fSon != null){
			if (fSon.getType() != 24){
				fSon = fSon.getNextSibling();
			}
			else {
				fSon = fSon.getNextSibling();
			}
		}
		return fSon;
	}
	private static String addExpression(AST sqlTree) {
		AST fSon = sqlTree;
		String s = "";
		while (fSon != null && isExpression(fSon)){
			//fSon = fSon.getNextSibling();
			undef++;
			if (undef == 0){
				s += "let No_Name be ";
			}
			else {
				s += "let No_Name" + undef  + " be ";
			}
			while (fSon != null && fSon.getType() != 24){
				s +=  visit(fSon);
				fSon = fSon.getNextSibling();
			}
			s += ";\n";
			fSon = nextExpression(fSon);
		}
		return s;
	}
	private static boolean isExpression(AST sqlTree) {
    	AST fSon = sqlTree;
		if (fSon.getNextSibling()!=null){
			if ((fSon.getNextSibling().getType() == 14) || (fSon.getNextSibling().getType() == 27) || (fSon.getNextSibling().getType() == 28) || (fSon.getNextSibling().getType() == 30)){
				return true;
			}
		}
		return false;
	}
	private static AST nextGroupBy(AST sqlTree) {
		AST nextGB = sqlTree;
		while ((nextGB!=null) && (nextGB.getType()!=107)){
			nextGB = nextGB.getNextSibling();
		}
		return nextGB;
	}
    private static boolean haveHaving(AST sqlTree) {
		AST nextGB = sqlTree;
		while ((nextGB!=null) && (nextGB.getType()!=108)){
			nextGB = nextGB.getNextSibling();
		}
		return (nextGB != null);
	}
    private static AST nextHaving(AST sqlTree) {
		AST nextGB = sqlTree;
		while ((nextGB!=null) && (nextGB.getType()!=108)){
			nextGB = nextGB.getNextSibling();
		}
		return nextGB.getNextSibling();
	}
	private static String addAliases(AST sqlTree, AST groupBy) {
		AST fSon = sqlTree;
		String s = "";
		while(fSon!=null){
			if (fSon.getType() == 9 || fSon.getType() == 12){
				if (fSon.getType() == 9){
					if (fSon.getNextSibling()!=null){
						if ((fSon.getNextSibling().getType() == 9) || (fSon.getNextSibling().getType() == 29)){
							s += "let ";
							if (fSon.getNextSibling().getType() == 9){
								s += visit(fSon.getNextSibling());
								s += " be ";
								s += visit(fSon.getFirstChild());
					    		s += ";\n";
					    		fSon = fSon.getNextSibling().getNextSibling();
							}
							else {
								s += visit(fSon.getNextSibling().getNextSibling());
								s += " be ";
								s += visit(fSon.getFirstChild());
					    		s += ";\n";
					    		fSon = fSon.getNextSibling().getNextSibling().getNextSibling();
							}
						}
						else {
							fSon = fSon.getNextSibling();
						}
					}
					else {
						fSon = fSon.getNextSibling();
					}
				}
				else {
					if (fSon.getNextSibling()!=null){					
						s += "let ";
						if ((fSon.getNextSibling().getType() == 9) || (fSon.getNextSibling().getType() == 29)){
							if (fSon.getNextSibling().getType() == 9){
								s += visit(fSon.getNextSibling());
								System.out.println(s);
								s += " be ";
								s += visitGroup(fSon, groupBy);
					    		s += ";\n";
					    		fSon = fSon.getNextSibling().getNextSibling();
							}
							else {
								s += visit(fSon.getNextSibling().getNextSibling());
								s += " be ";
								s += visitGroup(fSon, groupBy);
					    		s += ";\n";
					    		fSon = fSon.getNextSibling().getNextSibling().getNextSibling();
							}
						}
						else {
							undef++;
							if (undef == 0){
								s += "No_Name be ";
							}
							else {
								s += "No_Name" + undef  + " be ";
							}
							s += visitGroup(fSon, groupBy);
				    		s += ";\n";
							fSon = fSon.getNextSibling();
						}
					}
					else {				
						s += "let ";
						undef++;
						if (undef == 0){
							s += "No_Name be ";
						}
						else {
							s += "No_Name" + undef  + " be ";
						}
						s += visitGroup(fSon, groupBy);
			    		s += ";\n";
						fSon = fSon.getNextSibling();
					}
				}
			}
			else {
				fSon = fSon.getNextSibling();
			}
		}
		return s;
	}
	private static boolean haveAlias(AST sqlTree) {
		AST fSon = sqlTree;
		if (fSon.getNextSibling()!=null){
			if ((fSon.getNextSibling().getType() == 9) || (fSon.getNextSibling().getType() == 29)){
				return true;
			}
		}
		return false;
	}
	private static String getAlias(AST sqlTree) {
		AST fSon = sqlTree;
		String s = "";
		if (fSon.getNextSibling().getType() == 9){
			s += visit(fSon.getNextSibling());
		}
		else {
			s += visit(fSon.getNextSibling().getNextSibling());
		}
		return s;
	}
		private static String visitGroup(AST son, AST groupBy) {
		AST fSon = son.getFirstChild();
		String s ="";
		boolean isDistinct = false;
		if (groupBy != null){
			AST group = groupBy.getNextSibling().getNextSibling();
			if (fSon.getNextSibling().getNextSibling().getType()==21){
				s += " red max of fun ";
				isDistinct = true;
			}
			else {
				s += "equiv "; 
			}
			switch (fSon.getType()){
			case 60:
				s += "+";
				break;
			case 61:
				if (fSon.getNextSibling().getNextSibling().getType() == 25) {
					s += "+ of 1 by " + visit(group);
					return s;
				}
				else {
					if (isDistinct) {
						s += "+ of 1 order ";
						fSon = fSon.getNextSibling();
						while (fSon != null) {
							s += visit(fSon);
							fSon = fSon.getNextSibling();
						}
						s+= " by " + visit(group);
					}
					else {
						s += "+ of (if isnull";

						fSon = fSon.getNextSibling();
						while (fSon != null) {
							s += visit(fSon);
							fSon = fSon.getNextSibling();
						}
						s+= " then 0 else 1) by " + visit(group);
					}
					return s;
				}
			case 62:
				s += "max";
				break;
			case 63:
				s += "min";
				break;
			case 65:
				s += "+";
				break;
			}
			s += " of ";
			fSon = fSon.getNextSibling();
			String tmp = " order ";
			while (fSon != null) {
				s += visit(fSon);
				tmp += visit(fSon);
				fSon = fSon.getNextSibling();
			}
			if (isDistinct) {
				s += tmp; 				
			}
			s += " by ";
			s += visit(group);
			if (son.getFirstChild().getType() == 60) {
				if (isDistinct){
					s += " / red max of fun + of 1" + tmp + "by " + visit(group);
				}
				else {
					s += " / equiv + of 1 by " + visit(group);
				}
			}
		}
		else {
			if (fSon.getNextSibling().getNextSibling().getType()==21){
				s += " red max of fun ";
				isDistinct = true;
			}
			else {
				s += "red ";
			}
			switch (fSon.getType()){
			case 60:
				s += "+";
				break;
			case 61:
				if (fSon.getNextSibling().getNextSibling().getType() == 25) {
					s += "+ of 1";
					return s;
				}
				else {
					if (isDistinct) {
						s += "+ of 1 order ";
						fSon = fSon.getNextSibling();
						while (fSon != null) {
							s += visit(fSon);
							fSon = fSon.getNextSibling();
						}
					}
					else {
						s += "+ of (if isnull";

						fSon = fSon.getNextSibling();
						while (fSon != null) {
							s += visit(fSon);
							fSon = fSon.getNextSibling();
						}
						s+= " then 0 else 1)";
					}
					return s;
				}
			case 62:
				s += "max";
				break;
			case 63:
				s += "min";
				break;
			case 65:
				s += "+";
				break;
			}
			s += " of ";
			fSon = fSon.getNextSibling();
			String tmp = " order ";
			while (fSon != null) {
				s += visit(fSon);
				tmp += visit(fSon);
				fSon = fSon.getNextSibling();
			}
			if (isDistinct) {
				s += tmp; 				
			}
			if (son.getFirstChild().getType() == 60) {
				if (isDistinct){
					s += " / red max of fun + of 1" + tmp;
				}
				else {
					s += " / red + of 1";
				}
			}
		}
		return s;
	}
	public static String visitWhereJoin(AST sqlTree){
		String s = "";
		AST fSon = sqlTree;
		if (fSon.getType()==128) {
			if (isJoin(fSon.getFirstChild())) {
				fSon = fSon.getFirstChild();	
				s += "(" + fSon.getFirstChild().getText() + "[";
				fSon = fSon.getNextSibling().getNextSibling();
				s += visit(fSon);
				if (fSon.getNextSibling().getNextSibling().getType() == 27){
					fSon = fSon.getNextSibling().getNextSibling().getNextSibling();
					if (fSon.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling() != null && fSon.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling().getType() == 27){
						s += ":ujoin:";
					}
					else {
						s += ":rjoin:";
					}
				}
				else {
					if (fSon.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling() != null && fSon.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling().getType() == 27){
						s += ":ljoin:";
					}
					else {
						s += ":ijoin:";
					}
				}
				fSon = fSon.getNextSibling().getNextSibling();
				s += visit(fSon.getNextSibling().getNextSibling()) + "]";
				s += fSon.getFirstChild().getText() + ")";
			}
		}
		else {
			fSon = fSon.getFirstChild().getFirstChild();
			String tmp = visitWhereJoin(fSon);
			if (tmp != ""){
				s = tmp;
			}
			if (fSon.getNextSibling()!=null){
				tmp = visitWhereJoin(fSon.getNextSibling());
			}
			else {
				tmp = "";
			}
			if (s != "" && tmp != ""){
				if (s.indexOf("ijoin")>=0 && tmp.indexOf("ijoin")>=0 && sqlTree.getFirstChild().getType() == 87 && sqlTree.getFirstChild().getFirstChild().getNextSibling().getFirstChild().getType() != 89){
					s = s.replaceFirst(":ijoin", "," + tmp.substring(tmp.indexOf("[") + 1, tmp.indexOf(":")) + ":ijoin");
					s = s.replaceFirst("]",  "," + tmp.substring(tmp.lastIndexOf(":") + 1, tmp.indexOf("]") + 1));
				}
				else if (s.indexOf("ljoin")>=0 && tmp.indexOf("ljoin")>=0 && sqlTree.getFirstChild().getType() == 87 && sqlTree.getFirstChild().getFirstChild().getNextSibling().getFirstChild().getType() != 89){
					s = s.replaceFirst(":ljoin", "," + tmp.substring(tmp.indexOf("[") + 1, tmp.indexOf(":")) + ":ljoin");
					s = s.replaceFirst("]",  "," + tmp.substring(tmp.lastIndexOf(":") + 1, tmp.indexOf("]") + 1));
					}
				else if (s.indexOf("rjoin")>=0 && tmp.indexOf("rjoin")>=0 && sqlTree.getFirstChild().getType() == 87 && sqlTree.getFirstChild().getFirstChild().getNextSibling().getFirstChild().getType() != 89){
					s = s.replaceFirst(":rjoin", "," + tmp.substring(tmp.indexOf("[") + 1, tmp.indexOf(":")) + ":rjoin");
					s = s.replaceFirst("]",  "," + tmp.substring(tmp.lastIndexOf(":") + 1, tmp.indexOf("]") + 1));
				}
				else if (s.indexOf("ujoin")>=0 && tmp.indexOf("ujoin")>=0 && sqlTree.getFirstChild().getType() == 87 && sqlTree.getFirstChild().getFirstChild().getNextSibling().getFirstChild().getType() != 89){
					s = s.replaceFirst(":ujoin", "," + tmp.substring(tmp.indexOf("[") + 1, tmp.indexOf(":")) + ":ujoin");
					s = s.replaceFirst("]",  "," + tmp.substring(tmp.lastIndexOf(":") + 1, tmp.indexOf("]") + 1));
				}
				else if (s.indexOf("djoin")>=0 && tmp.indexOf("djoin")>=0 && sqlTree.getFirstChild().getType() == 87 && sqlTree.getFirstChild().getFirstChild().getNextSibling().getFirstChild().getType() != 89){
					s = s.replaceFirst(":djoin", "," + tmp.substring(tmp.indexOf("[") + 1, tmp.indexOf(":")) + ":djoin");
					s = s.replaceFirst("]",  "," + tmp.substring(tmp.lastIndexOf(":") + 1, tmp.indexOf("]") + 1));
				}
				else {
					String op = "";
					if (sqlTree.getFirstChild().getType() == 87){
						if (sqlTree.getFirstChild().getFirstChild().getNextSibling().getFirstChild().getType() == 89){
							op = "djoin";
						}
						else {
							op = "ijoin";
						}
					}
					else {
						op = "ujoin";
					}
					s = s + " " + op + " " + tmp;
				} 
			}
			else {
				if (tmp != ""){
					s = tmp;
				}
			}
		}
		return s;
	}
	private static AST nextClause(AST sqlTree) {
		AST fSon=sqlTree;
		while (fSon!=null && fSon.getType() != 86 && fSon.getType() != 87){
			fSon = fSon.getNextSibling();
		}
		if (fSon==null){
			return null;
		}
		else {
			return fSon.getNextSibling();
		}
	}
	public static String visitWhere(AST sqlTree){
		String s = "";
		AST fSon = sqlTree;
		if (fSon.getType()==128) {
			if (!isJoin(fSon.getFirstChild())) {
				if (fSon.getFirstChild().getNextSibling().getType()==91){
					s = "ATT=\"" + visit(fSon);
				}
				else {
					s = visit(fSon);
				}
			}
		}
		else {
			fSon = fSon.getFirstChild().getFirstChild();
			String tmp = visitWhere(fSon);
			if (tmp != ""){
				s = tmp;
			}
			if (fSon.getNextSibling()!=null){
				tmp = visitWhere(fSon.getNextSibling());
			}
			else {
				tmp = "";
			}
			if (s != "" && tmp != ""){
				s = s + " " + sqlTree.getFirstChild().getText() + " " + tmp; 
			}
			else {
				if (tmp != ""){
					s = tmp;
				}
			}
		}
		return s;
	}
	public static boolean isJoin(AST sqlTree){
		AST fSon = sqlTree;
		
		while (fSon!=null &&  fSon.getType()!=10){
			fSon = fSon.getNextSibling();
		}
		if (fSon == null){
			fSon = sqlTree;
			if ((fSon.getNextSibling().getType() != 26)){
				if (rel != null && dom != null){
					if (fSon.getNextSibling().getType() != 26){
						for (int j = 0; j<rel.length;j++){
							 if (dom[j].equalsIgnoreCase(visit(fSon)) && (rel[j].equalsIgnoreCase(tableList[0]) || rel[j].equalsIgnoreCase(tableList[1]))){
			            		 ASTFactory astF = new ASTFactory();
			            			AST RelId = astF.create(9, "sql_identifier");
			            			RelId.addChild(astF.create(120, rel[j]));
			            			RelId.setNextSibling(astF.create(26, "."));
			            			RelId.getNextSibling().setNextSibling(astF.create(fSon.getType(), fSon.getText()));
			            			RelId.getNextSibling().getNextSibling().setFirstChild(fSon.getFirstChild());
			            			RelId.getNextSibling().getNextSibling().setNextSibling(fSon.getNextSibling());
			            			sqlTree.setFirstChild(RelId.getFirstChild());
			            			sqlTree.setNextSibling(RelId.getNextSibling());
			            			sqlTree.setText(RelId.getText());
			            			sqlTree.setType(RelId.getType());
			            		}
						}
					}
					if ((sqlTree.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling()== null) || (sqlTree.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling().getType()!=26)){
						fSon = sqlTree.getNextSibling().getNextSibling().getNextSibling().getNextSibling();
						for (int j = 0; j<rel.length;j++){
			        		 if (dom[j].equalsIgnoreCase(visit(fSon)) && (rel[j].equalsIgnoreCase(tableList[0]) || rel[j].equalsIgnoreCase(tableList[1]))){
		            			 ASTFactory astF = new ASTFactory();
			            			AST RelId = astF.create(9, "sql_identifier");
			            			RelId.addChild(astF.create(120, rel[j]));
			            			RelId.setNextSibling(astF.create(26, "."));
			            			RelId.getNextSibling().setNextSibling(fSon);
			            			sqlTree.getNextSibling().getNextSibling().getNextSibling().setNextSibling(RelId);
				        	}
						}
					}
					fSon = sqlTree;					
				}
				else {
				return false;
				}
			}
			if ((fSon.getNextSibling().getType() == 26) && (fSon.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getNextSibling().getType()==26) && visit(fSon.getFirstChild()).equalsIgnoreCase(visit(fSon.getNextSibling().getNextSibling().getNextSibling().getNextSibling().getFirstChild()))){
				return false;
			}
			else {
				return true;
			}
		}
		else {
			return false;
		}
	}
	public static boolean isJoinGlobal(AST sqlTree){
		AST fSon = sqlTree;
		if (fSon.getType()==128) {
			return isJoin(fSon.getFirstChild());
		}
		else {
			fSon = fSon.getFirstChild().getFirstChild();
			if (fSon.getNextSibling()!=null) {
				return (isJoinGlobal(fSon) || isJoinGlobal(fSon.getNextSibling()));
			}
			else {
				return (isJoinGlobal(fSon));
			}
		}
	}
	public static int numberOfTables(AST sqlTree){
		int num = 0;
		AST fSon = sqlTree.getFirstChild();
		while (fSon!=null){
			if (fSon.getType()==9){
				num++;
			}
			fSon = fSon.getNextSibling();
		}
		return num;
	}
	public static AST parseWhereCondition(AST sqlTree){
		ASTFactory astF = new ASTFactory();
		AST whereAST = astF.create(125, "Boolean_Expression");
		AST tmpChild;
		AST tmpParent = null;
		AST fSon = sqlTree;
		tmpChild = astF.create();
		//tmpChild.setFirstChild(astF.create(fSon.getType(), fSon.getText()));
		if (fSon.getType() == 17){
			fSon = fSon.getNextSibling();
			while (fSon.getType() != 18){
				tmpChild.addChild(astF.dupTree(fSon));
				fSon = fSon.getNextSibling();
			}
			//tmpParent = astF.create(125, "Boolean_Expression");
			fSon = fSon.getNextSibling();
			if (fSon == null ||  !(fSon.getType() == 86 || fSon.getType() == 87)){
				tmpParent = parseWhereCondition(tmpChild.getFirstChild());
				whereAST = tmpParent;				
			}
			else {
				
				tmpChild = parseWhereCondition(tmpChild.getFirstChild());
				//tmpParent = astF.create(126, "Left_Op");
				//tmpParent.addChild(tmpChild);
				//System.out.println("ok");
				//tmpChild = astF.dupTree(tmpParent);
				tmpParent = astF.create(fSon);
				tmpParent.addChild(tmpChild);
				whereAST.addChild(tmpParent);
				//tmpParent.addChild(tmpChild);
				//tmpChild = astF.create(127, "Right_Op");
				tmpChild = parseWhereCondition(fSon.getNextSibling());
				tmpParent.addChild(tmpChild);
			}
		}
		else {
		while (fSon != null && !(fSon.getType() == 86 || fSon.getType() == 87 || fSon.getType() == 89)) {
			//else {
				//System.out.println("ok" + fSon.getText());
				tmpChild.addChild(astF.dupTree(fSon));	
				//System.out.println("ok2");			
			//}
			fSon = fSon.getNextSibling();
		}
		if (fSon == null){
			tmpChild.setType(128);
			tmpChild.setText("Non_Boolean_Expression");
			whereAST = tmpChild;			
		}
		else if (fSon.getType() == 89){
			tmpChild = parseWhereCondition(fSon.getNextSibling());
			//tmpParent = astF.create(126, "Left_Op");
			//tmpParent.addChild(tmpChild);
			//tmpChild = astF.dupTree(tmpParent);
			tmpParent = astF.create(fSon);
			tmpParent.addChild(tmpChild);
			whereAST.addChild(tmpParent);
		}
		else {
			tmpChild.initialize(128, "Non_Boolean_Expression");
			//tmpParent = astF.create(126, "Left_Op");
			//tmpParent.addChild(tmpChild);
			//tmpChild = astF.dupTree(tmpParent);
			tmpParent = astF.create(fSon);
			tmpParent.addChild(tmpChild);
			whereAST.addChild(tmpParent);
			//tmpParent.addChild(tmpChild);
			//System.out.println("ok2");
			//tmpChild = astF.create(127, "Right_Op");
			tmpChild = parseWhereCondition(fSon.getNextSibling());
			tmpParent.addChild(tmpChild);
		}
		}
        //DumpASTVisitor v = new DumpASTVisitor();
        //v.visit(whereAST);
		return whereAST;
	}
}

